﻿// ================================================================
var SCRIPT_FILE = new File( $.fileName );

var script = {
	name: 'findChangeSets',
	version: 1.11,
	versionStr: function(){
		return this.version%1 ? this.version.toString() : this.version+'.0';
		},
	insertLabel: function( string ){
		app.insertLabel( this.name, string );
		},
	extractLabel: function(){
		return app.extractLabel( this.name );
		},
	};

//========= ЛОКАЛИЗАЦИЯ ================================================

var lang = ( $.locale == 'ru_RU' ) ? 'ru' : 'en';
var messages = {
	en: {
		searchArea: 'Search area: ',
		document: 'Document',
		selectedStory: 'Selected story',
		selectedText: 'Selected text',
		selectedTable: 'Selected table',
		selectedCells: 'Selected cells',
		selectedRows: 'Selected rows',
		selectedColumns: 'Selected columns',
		
		noOpenDocs: 'No open documents',
		processFullDoc: 'Document will be processed completely.\r\rContinue?',
		showReport: 'Show report',
		preset: 'Preset',
		newPreset: 'New preset',
		find: 'Find',
		change: 'Change',
		incorrectName: 'Incorrect name',
		presetAlreadyExists: 'Preset already exists',
		savePreset: 'Save preset',
		save: 'Save',
		saveAs: 'Save As',
		'delete': 'Delete',
		execute: 'Execute',
		
		charStyle: 'Character style',
		parStyle: 'Paragraph style',
		
		options: 'Options',
		columns: 'Columns',
		columnWidth: 'Column width',
		activeHelpTip: 'Позволяет отключать отдельные элементы набора',
		methodHelpTip: 'Тип запроса: Text или Grep. Если отключить эту колонку - для всех элементов набора будет использован тип Text',
		},
	ru: {
		searchArea: 'Зона поиска: ',
		document: 'Документ',
		selectedStory: 'Выдел. материал',
		selectedText: 'Выдел. текст',
		selectedTable: 'Выдел. таблица',
		selectedCells: 'Выдел. ячейки',
		selectedRows: 'Выдел. строки',
		selectedColumns: 'Выдел. столбцы',
		
		noOpenDocs: 'Нет открытых документов',
		processFullDoc: 'Будет обработано содержание всего документа.\r\rПродолжить?',
		showReport: 'Показывать отчет после выполнения набора замен',
		preset: 'Набор',
		newPreset: 'Новый набор',
		find: 'Найти',
		change: 'Заменить',
		incorrectName: 'Некорректное имя',
		presetAlreadyExists: 'Такой набор уже есть',
		savePreset: 'Сохранить набор',
		save: 'Сохранить',
		saveAs: 'Сохранить как',
		'delete': 'Удалить',
		execute: 'Выполнить',
		
		charStyle: 'Стиль символа',
		parStyle: 'Стиль абзаца',
		
		options: 'Настройки',
		columns: 'Колонки',
		columnWidth: 'Ширина колонки',
		activeHelpTip: 'Позволяет отключать отдельные элементы набора',
		methodHelpTip: 'Тип запроса: Text или Grep. Если отключить эту колонку - для всех элементов набора будет использован тип Text',
		}
	};
function getLocale(key){
	return messages[lang][key] || key;
	}

// ============ INI =======================

if( !app.documents.length ){
	alert( getLocale('noOpenDocs') );
	exit();
	}
var DOC = app.documents[0];

var PROCESSED_XML;

var settings_button = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x021IDATx\u00DA\u00A4S\u00B9\u008A\"Q\x14\u00BD\u00E5\u00D6\"*\u00EE\x18\u00B84\u0088\n\"4\u0082\u008A\u00A0\u00A0\r\u0086\u00E6\u00FE\u0080\u0098\x1A\x1A\u00AA\u00FF`b\u00D8\u00A1\u0099\u0081\u00A1\u00E0\f\n\u00AD(Hc\u00E6\u009A(\u0088\u00BB\u0091\u00B8O\u009D\u0087\u00CA\f3\x1D\u00CD\u0083[u\u00EA\u00DEs^\u00DDz\u00E7\x16W(\x14\u00E8\u009B\u0095\u00E5#s\u00C7\u00B9\u00FB\u00F3_Kp\u00BD^)\x1A\u008D\x12\x7F\u00CF\u00F2Q\x05\u00BE?g\u00BE\u00C1Up\u00EF\u0098\u00B8|>\u00FF|\u009B\u00CF\u00E7\u00A3\u00E1pH\x1A\u008D\u0086\u00D4j5i\u00B5Z\u00BA\u00DDn\u00B4^\u00AFi\u00B3\u00D9\u00B0\u00BB\u00CDf\u00A3V\u00AB\u00F5\u00ECJt\u00B9\\\u00F0\x10\u00F6z\u00BD\u00A4\u00D3\u00E9H\u00A9T2\u00E2b\u00B1`\x18\x0B\x18\x1BZ\u00ADV\u0092H$\u00E4\u00F1x\u00A8\u00DDn\u0087\u00D9'`\u0083X,\u00F6\u00DE\u00EF\u00F7i\u00BF\u00DF\u0093@ `d\u00BB\u00DDNb\u00B1\u0098\x050r\u00A8\u0081\x03.4\u00D0\u008A\u00CE\u00E73{\u008BB\u00A1\u00A0\u00F9|Nz\u00BD\u009E^^^\u00A8\u00D1hP\u00BD^g\u00B5P(D\u0081@\u0080\x0E\u0087\x03\u00EB\x06\\,h\x05\u00FC%[,\x16oH\u00A2(\x14\n\u00D1\x1E\u00E2G:\u009D\u00E6\x10\u00C0\u00C8\u00A1\u00F6\u00D8\x00\x1Ah\u00B1A&\x1E\u008F\u0093\u00D1h$\u00B3\u00D9L\"\u0091\u0088\u00BA\u00DD.\u00A5R\u00A9\u00F7\u0087U\u00C0\u00C8\u00A1\x06\x0E\u00B8\u00D0@+:\u009DN4\u0099L\u00FE\u00F0\u00F6\u00D1\u00E2\u00BFr\u00E0\u00C3\x11\x04\u00B00\x18\fr\u0083\u00C1 \u0082\x13\u009FN\u00A7d0\x18H.\u0097\u00D3\u00E7\u00E7g\u00C4\u00E1p|@T.\u0097\u00ABn\u00B7\u00FBU*\u0095\u00B2\u00EEpx\u00B5Z\rs\u0090cg\u0090H$\u00B8\u00E5r\u00C9\u0084\u00BB\u00DD\u008E\u00D9\u00E5r\u00B9\"\u0095J\u00E5\u0086\x00F\x0E5p\u00C0\u0085\x06\u00DA\u00A7\x0B8\x1C\u0093\u00C9\u00C4\x1C\u0098\u00CDf\u00CC6L\x1B\x16\u00DAEN&\u0093\u00B1\r`\u00E3\u00C3\x05\u00A1\u00DF\u00EF\u00A7f\u00B3Yu:\u009D\u00AF\x18\u00A6\u00D1h\u00C4\u00C8\u00BD^\u008F\u008E\u00C7#\u00B3\u00F6\u00EB\u00EB\u008BY\u0088\u00D6\u00F9O\u00A1\u00EDvK\u00A5R)\u00C2O\u00E9\u00C7c\x12\x7F\u00F26E\u0080\u00C7\u00E31{\u00BBJ\u00A5\u00A2\u00DFgd\u00B5Z\x11\x7FV\u00AC\u00FDN\u00A7\u00C34\u00CFI\f\u0087\u00C3Y\u00FE\u009E\u0083\u00DFooo\u009C\u00C5b\u0081\u00F7\u00ECgA\x00#\u0087\x1A8\u00E0\u00DE5\u00C4%\u0093\u00C9\u00FF\u00FA\u009D\x7F\t0\x00I\\i\u00A5H\x00\u00EA^\x00\x00\x00\x00IEND\u00AEB`\u0082";

// ============ OPTIONS ==================
var OPTS = {
	lastPresetName: '',
	showReport: false,
	
	findWhatWidth: 200,
	changeToWidth: 200,
	
	active: true,
	activeWidth: 50,
	method: true,
	methodWidth: 70,
	findCharStyle: false,
	findCharStyleWidth: 200,
	findParStyle: false,
	findParStyleWidth: 200,
	changeCharStyle: false,
	changeCharStyleWidth: 200,
	changeParStyle: false,
	changeParStyleWidth: 200
	}

function saveOptions(){
	script.insertLabel( 'OPTS = ' + OPTS.toSource() );
	}

// ini options
try{ eval( script.extractLabel() ) }catch( err ){ alertError( err, 'Ini options' ) }; 

// ============ PRESETS ==================

var PRESETS_FOLDER = new Folder( SCRIPT_FILE.parent.absoluteURI + '/' + script.name );
XML.prettyPrinting = true; // Включаем табуляцию и абзацы у строкового представления xml

function getPresetFilesBasa(){
	PRESETS_FOLDER.create();
	var PRESET_FILES = PRESETS_FOLDER.getFiles( '*.xml' );
	var basa = {};
	for( var i = 0; i < PRESET_FILES.length; i++ )
		basa[getFileNameOnly(PRESET_FILES[i])] = PRESET_FILES[i];
	return basa;
	}

function getDefaultXmlPreset(){
	return <{script.name} version={script.versionStr()}>
<!--		<query/> -->
	</{script.name}>;
	}

//======== ПРОВЕРЯЕМ ЧТО У НАС ВЫДЕЛЕНО ================================

// Определяем область обработки (взято из findChangeQueryList2)
var AREA; // object
var searchArea = ''; // title
if(app.selection[0] == undefined){
	if( !confirm( getLocale('processFullDoc'), true, script.name ) )
		exit();
	AREA = app.activeDocument;
	searchArea = getLocale('searchArea') + getLocale('document');
	}
else
	switch(app.selection[0].constructor.name){
		case 'TextFrame':
		case 'InsertionPoint':
		AREA = app.selection[0].parentStory; // Цепочка фреймов
		searchArea = getLocale('searchArea') + getLocale('selectedStory');
		break;
		case 'Text':
		case 'TextColumn':
		case 'Paragraph':
		case 'Table':
		case 'Cell':
		case 'Row':
		case 'Column':
		AREA = app.selection[0];
		
		switch(app.selection[0].constructor.name){
			case 'Text':
			case 'TextColumn':
			case 'Paragraph':
			searchArea = getLocale('searchArea') + getLocale('selectedText');
			break;
			case 'Table':
			searchArea = getLocale('searchArea') + getLocale('selectedTable');
			break;
			case 'Cell':
			searchArea = getLocale('searchArea') + getLocale('selectedCells');
			break;
			case 'Row':
			searchArea = getLocale('searchArea') + mgetLocale('selectedRows');
			break;
			case 'Column':
			searchArea = getLocale('searchArea') + getLocale('selectedColumns');
			break;
			}
		
		break;
		default:
		if( !confirm( 'Current selection: ' +app.selection[0].constructor.name+'.\r\r' + getLocale('processFullDoc'), true, script.name ) )
			exit();
		AREA = app.activeDocument;
		searchArea = getLocale('searchArea') + getLocale('document');
		}

//=====================================================================
// PROCESS
//=====================================================================

var SHOW_DIALOG = true;
var CHAR_STYLES;
var PAR_STYLES;

while( SHOW_DIALOG ){
	
	if( !CHAR_STYLES )
		CHAR_STYLES = OPTS.findCharStyle || OPTS.changeCharStyle ? getStylesList( 'character' ) : null;
	if( !PAR_STYLES )
		PAR_STYLES = OPTS.findParStyle || OPTS.changeParStyle ? getStylesList( 'paragraph' ) : null;
	
	getDialog();
	
	if( PROCESSED_XML ){
		var queries = OPTS.active ? PROCESSED_XML.xpath( "query[@enable = 'true']" ) : PROCESSED_XML.query; // PROCESSED_XML.xpath( "query[@enable = 'true' and @findWhat != '']" )
		var report = [];
		var res;
		var findPrefs, changePrefs, flag, styleName;
		if( queries.length() ){
			for( var i = 0; i < queries.length(); i++ ){
				
				// ini findPrefs
				findPrefs = {};
				flag = false;
				if( OPTS.findCharStyle ){
					styleName = queries[i].@findCharStyle.toString();
					if( styleName && CHAR_STYLES.ids[styleName] ){
						flag = true;
						findPrefs.appliedCharacterStyle = app.documents[0].characterStyles.itemByID( CHAR_STYLES.ids[styleName] );
						}
					}
				if( OPTS.findParStyle ){
					styleName = queries[i].@findParStyle.toString();
					if( styleName && PAR_STYLES.ids[styleName] ){
						flag = true;
						findPrefs.appliedParagraphStyle = app.documents[0].paragraphStyles.itemByID( PAR_STYLES.ids[styleName] );
						}
					}
				if( !flag && queries[i].@findWhat.toString() == '' )
					continue;
				
				// ini changePrefs
				changePrefs = {};
				flag = false;
				if( OPTS.changeCharStyle ){
					styleName = queries[i].@changeCharStyle.toString();
					if( styleName && CHAR_STYLES.ids[styleName] ){
						flag = true;
						changePrefs.appliedCharacterStyle = app.documents[0].characterStyles.itemByID( CHAR_STYLES.ids[styleName] );
						}
					}
				if( OPTS.changeParStyle ){
					styleName = queries[i].@changeParStyle.toString();
					if( styleName && PAR_STYLES.ids[styleName] ){
						flag = true;
						changePrefs.appliedParagraphStyle = app.documents[0].paragraphStyles.itemByID( PAR_STYLES.ids[styleName] );
						}
					}
				if( !flag && queries[i].@changeTo.toString() == '' )
					continue;
				
				// doFindChange
				res = doFindChange({
					type: OPTS.method ? queries[i].@method.toString() : 'Text', 
					
					area: AREA, 
					
					findWhat: queries[i].@findWhat.toString(),
					findPreferences: findPrefs, 
					
					changeTo: queries[i].@changeTo.toString(), 
					changePreferences: changePrefs, 
					
					topLevelOnly: true
					} );
				report.push( res.length + ': "' + queries[i].@findWhat.toString() + '" > "' + queries[i].@changeTo.toString() + '"' );
				}
			}
		if( OPTS.showReport && report.length )
			alert( report.join('\r'), 'Result' );
		}
	}

saveOptions();
// ============ DIALOG ================================================
function getDialog(){
	SHOW_DIALOG = false;
	
	var win = new Window( "dialog", script.name + ' v.' + script.versionStr() + ' ['+searchArea+']', undefined );
	win.alignChildren = ['left', 'top'];
	win.margins = 5;
	win.spacing = 5;
	with(win){
		win.line = add( "panel", undefined, undefined );
		win.line.preferredSize.height = 2;
		win.line.alignment = ['fill', 'top'];
		win.presets = add( "group", undefined, undefined );
		win.presets.spacing = 5;
		with(win.presets){
			add( "statictext", undefined,  getLocale('preset') ).indent = 5;
			win.presets.ddList = add( "dropdownlist", undefined, undefined, {items: ['...','-'], } );
			win.presets.ddList.preferredSize.width = 200;
			
			//win.presets.save = add( "button", undefined, getLocale('save') );
			win.presets.save = add("iconbutton", undefined, undefined, {style: "toolbutton"});
			win.presets.save.preferredSize = [22,22];
			addIcon( { iconButton: win.presets.save, iconPath: "Text/(Find and Change Panel Resources)/idrc_PNGA/117.idrc", text: 'S', helpTip: getLocale('save') } );
			
			//win.presets.saveAs = add( "button", undefined, getLocale('saveAs') );
			win.presets.saveAs = add("iconbutton", undefined, undefined, {style: "toolbutton"});
			win.presets.saveAs.preferredSize = [30,22];
			addIcon( { iconButton: win.presets.saveAs, iconPath: "Layout/(Links UI Resources)/idrc_PNGR/160.idrc", text: 'sA', helpTip: getLocale('saveAs') } );
			
			//win.presets.delete = add( "button", undefined, getLocale('delete') );
			win.presets.delete = add("iconbutton", undefined, undefined, {style: "toolbutton"});
			win.presets.delete.preferredSize = [22,22];
			addIcon( { iconButton: win.presets.delete, iconPath: "Text/(Find and Change Panel Resources)/idrc_PNGA/118.idrc", text: 'D', helpTip: getLocale('delete') } );
			
			}
		win.line = add( "panel", undefined, undefined );
		win.line.preferredSize.height = 2;
		win.line.alignment = ['fill', 'top'];
		
		win.findChange = add( "panel", undefined, getLocale('find')+'/'+getLocale('change') );
		win.findChange.enabled = false;
		
		win.buts = add( "group", undefined, undefined );
		win.buts.alignment = ['fill', 'top'];
		with(win.buts){
			
			//win.buts.options = add( "button", undefined, getLocale('options') );
			win.buts.options = add("iconbutton", undefined, undefined, {style: "toolbutton"} );
			win.buts.options.alignment = ['left','center'];
			win.buts.options.image = ScriptUI.newImage( settings_button );
			win.buts.options.helpTip = getLocale('options');
			
			win.buts.cancel = add( "button", undefined, 'Cancel' );
			win.buts.cancel.alignment = ['right', 'top'];
			win.buts.OK = add( "button", undefined, getLocale('execute') );
			win.buts.OK.alignment = ['right', 'top'];
			}
		}
	
	var fields = [];
	if( OPTS.active )
		fields.push( {
			type: "checkbox", // edittext | checkbox | radiobutton | dropdownlist
			key: "enable",
			title: "Active",
			width: OPTS.activeWidth, // number,
			default_value: "true",
			//values: ["","",""], // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			//missingValuePrefix: '', // Only for radiobutton | dropdownlist
			//missingValuePostfix: '',  // Only for radiobutton | dropdownlist
			//dropdownlistEmptyValue: false, 
			//edittextMultiline: false,
			//edittextScrolling: false, 
			helpTip: "",
		} );
	
	if( OPTS.method )
		fields.push( {
			type: "radiobutton", // edittext | checkbox | radiobutton | dropdownlist
			key: "method",
			title: "Method",
			width: OPTS.methodWidth, // number,
			default_value: "Text",
			values: ["Text","Grep"], // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			missingValuePrefix: '', // Only for radiobutton | dropdownlist
			missingValuePostfix: '',  // Only for radiobutton | dropdownlist
			//dropdownlistEmptyValue: false, 
			//edittextMultiline: false,
			//edittextScrolling: false, 
			helpTip: "",
		} );
	
	fields.push( {
		type: "edittext", // edittext | checkbox | radiobutton | dropdownlist
		key: "findWhat",
		title: 'Find',
		width: OPTS.findWhatWidth, // number,
		default_value: "",
		//values: ["","",""], // array of strings // Only for radiobutton | dropdownlist | multi checkbox
		//missingValuePrefix: '', // Only for radiobutton | dropdownlist
		//missingValuePostfix: '',  // Only for radiobutton | dropdownlist
		//dropdownlistEmptyValue: false, 
		edittextMultiline: false,
		edittextScrolling: false, 
		helpTip: "",
	} );

	if( OPTS.findCharStyle )
		fields.push( {
			type: "dropdownlist", // edittext | checkbox | radiobutton | dropdownlist
			key: "findCharStyle",
			title: "charStyle",
			width: OPTS.findCharStyleWidth, // number,
			default_value: "",
			values: CHAR_STYLES.names, // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			missingValuePrefix: '[', // Only for radiobutton | dropdownlist
			missingValuePostfix: ']',  // Only for radiobutton | dropdownlist
			dropdownlistEmptyValue: true, 
			//edittextMultiline: false,
			//edittextScrolling: false, 
			helpTip: getLocale('find')+': '+getLocale('charStyle'),
		} );
	
	if( OPTS.findParStyle )
		fields.push( {
			type: "dropdownlist", // edittext | checkbox | radiobutton | dropdownlist
			key: "findParStyle",
			title: "parStyle",
			width: OPTS.findParStyleWidth, // number,
			default_value: "",
			values: PAR_STYLES.names, // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			missingValuePrefix: '[', // Only for radiobutton | dropdownlist
			missingValuePostfix: ']',  // Only for radiobutton | dropdownlist
			dropdownlistEmptyValue: true,
			//edittextMultiline: false,
			//edittextScrolling: false,
			helpTip: getLocale('find')+': '+getLocale('parStyle'),
		} );

	fields.push( {
		type: "edittext", // edittext | checkbox | radiobutton | dropdownlist
		key: "changeTo",
		title: 'Change',
		width: OPTS.changeToWidth, // number,
		default_value: "",
		//values: ["","",""], // array of strings // Only for radiobutton | dropdownlist | multi checkbox
		//missingValuePrefix: '', // Only for radiobutton | dropdownlist
		//missingValuePostfix: '',  // Only for radiobutton | dropdownlist
		//dropdownlistEmptyValue: false, 
		edittextMultiline: false,
		edittextScrolling: false, 
		helpTip: "",
	} );
	
	if( OPTS.changeCharStyle )
		fields.push( {
			type: "dropdownlist", // edittext | checkbox | radiobutton | dropdownlist
			key: "changeCharStyle",
			title: "charStyle",
			width: OPTS.changeCharStyleWidth, // number,
			default_value: "",
			values: CHAR_STYLES.names, // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			missingValuePrefix: '[', // Only for radiobutton | dropdownlist
			missingValuePostfix: ']',  // Only for radiobutton | dropdownlist
			dropdownlistEmptyValue: true, 
			//edittextMultiline: false,
			//edittextScrolling: false, 
			helpTip: getLocale('change')+': '+getLocale('charStyle'),
		} );
	
	if( OPTS.changeParStyle )
		fields.push( {
			type: "dropdownlist", // edittext | checkbox | radiobutton | dropdownlist
			key: "changeParStyle",
			title: "parStyle",
			width: OPTS.changeParStyleWidth, // number,
			default_value: "",
			values: PAR_STYLES.names, // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			missingValuePrefix: '[', // Only for radiobutton | dropdownlist
			missingValuePostfix: ']',  // Only for radiobutton | dropdownlist
			dropdownlistEmptyValue: true, 
			//edittextMultiline: false,
			//edittextScrolling: false, 
			helpTip: getLocale('change')+': '+getLocale('parStyle'),
		} );
	
	getUIQueriesList( win.findChange, fields );
	
	// PRESETS
	win.presets.ddList.onChange = function(){
		try{
		if( this.SLEEP )
			return;
		
		if( win.presets.ddList.children.length == 2 )
			win.findChange.enabled = false;
			
		if( !this.selection ){
			win.findChange.enabled = false;
			return;
			}
		
		// сохраняем текущий
		if( this.lastPresetName ){
			var listItem = win.presets.ddList.find( this.lastPresetName );
			if( listItem && listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
				var res = confirmWithCancel( getLocale('savePreset') + " '" + listItem.text + "'?" ); // defaultButton = ok|no|cancel, return true|false|null
				if( res === null ){
					this.SLEEP = true;
					this.selection = listItem;
					this.SLEEP = false;
					return;
					}
				else if( res ){
					write_xml_file( listItem.presetFile, win.findChange.XML );
					listItem.savedXmlStr = win.findChange.XML.toXMLString();
					}
				}
			}
		
		// New preset
		if( this.selection.text == '...' ){ 
			var newName = prompt( getLocale('newPreset')+': ', '', script.name );
			var flag = true;
			if( !newName )
				flag = false;
			else if( newName == '...' ){
				alert( getLocale('incorrectName')+': ...' );
				flag = false;
				}
			else{
				newName = adaptForFileName( newName );
				if( this.find(newName) ){
					alert( getLocale('presetAlreadyExists')+': ' + newName );
					flag = false;
					}
				}
			if( !flag ){
				if( this.lastPresetName && this.find(this.lastPresetName) ){
					this.SLEEP = true;
					this.selection = this.find(this.lastPresetName);
					this.SLEEP = false;
					}
				else
					this.selection = null;
				return;
				}
			
			// load new xml
			win.findChange.loadXml( getDefaultXmlPreset() );
			win.findChange.enabled = true;
			// create xml file
			var xml_file = new File( PRESETS_FOLDER.absoluteURI + '/'+ newName + '.xml' );
			write_xml_file(xml_file, win.findChange.XML);
			// add listItem
			var listItem = win.presets.ddList.add( 'item', newName );
			listItem.presetFile = xml_file;
			listItem.savedXmlStr = win.findChange.XML.toXMLString();
			// select listItem
			this.SLEEP = true;
			win.presets.ddList.selection = win.presets.ddList.find( newName );
			this.SLEEP = false;
			// запоминаем текущий пресет
			this.lastPresetName = newName;
			}
		// Load selected preset
		else{
			// load new xml
			win.findChange.loadXml( read_xml_file(this.selection.presetFile) );
			this.selection.savedXmlStr = win.findChange.XML.toXMLString();
			win.findChange.enabled = true;
			// запоминаем текущий пресет
			this.lastPresetName = this.selection.text; 
			}
		}catch(err){ alertError( err ) }
		}
	win.presets.save.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var listItem = win.presets.ddList.selection;
		if( listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
			write_xml_file( listItem.presetFile, win.findChange.XML );
			listItem.savedXmlStr = win.findChange.XML.toXMLString();
			}
		}
	win.presets.saveAs.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var newName = prompt( getLocale('saveAs')+': ', '', script.name );
		if( !newName )
			return;
		newName = adaptForFileName( newName );
		if( newName == '...' ){
			alert( getLocale('incorrectName')+': ...' );
			return;
			}
		if( win.presets.ddList.find(newName) ){
			alert( getLocale('presetAlreadyExists')+': ' + newName );
			return;
			}
		
		// create xml file
		var xml_file = new File( PRESETS_FOLDER.absoluteURI + '/'+ newName + '.xml' );
		write_xml_file(xml_file, win.findChange.XML);
		// add listItem
		var listItem = win.presets.ddList.add( 'item', newName );
		listItem.presetFile = xml_file;
		listItem.savedXmlStr = win.findChange.XML.toXMLString();
		// select listItem
		win.presets.ddList.SLEEP = true;
		win.presets.ddList.selection = win.presets.ddList.find( newName );
		win.presets.ddList.SLEEP = false;
		// запоминаем текущий пресет
		win.presets.ddList.lastPresetName = newName; 
		}
	win.presets.delete.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var itemList = win.presets.ddList.selection;
		if( !confirm(getLocale('delete')+" '" + itemList.text +"'?") )
			return;
		itemList.presetFile.remove();
		win.presets.ddList.remove( itemList );
		win.findChange.loadXml( getDefaultXmlPreset() );
		
		win.presets.ddList.lastPresetName = '';
		win.presets.ddList.selection = null;
		}
	
	// Options
	win.buts.options.onClick = function(){
		if( saveCurrentPreset() === null )
			return false; //прерываем
		
		// сбрасываем выбор набора, чтобы диалог закрылся
		win.presets.ddList.selection = null;
		win.close();
		getOptionsDialog();
		}
	
	// cancel, OK, onClose
	var STATUS = false;
	
	win.buts.cancel.onClick = function(){
		this.window.close();
		}
	
	win.buts.OK.onClick = function(){
		STATUS = true;
		this.window.close();
		}
	win.defaultElement = win.buts.OK;
	
	win.onClose = function(){
		OPTS.lastPresetName = win.presets.ddList.lastPresetName;
		
		if( !win.presets.ddList.selection )
			return;
		
		if( saveCurrentPreset() === null )
			return false; //прервать выход 
		
		PROCESSED_XML = STATUS ? win.findChange.XML : undefined;
		}
	
	// INI PRESET
	var basa = getPresetFilesBasa();
	var listItem;
	for( var presetName in basa ){
		win.presets.ddList.add( 'item', presetName ).presetFile = basa[presetName];
		}
	if( OPTS.lastPresetName )
		win.presets.ddList.selection = win.presets.ddList.find( OPTS.lastPresetName );
//	win.presets.ddList.onChange();
	
	win.center();
	win.show();
	
	function saveCurrentPreset(){ // return true|false|null
		var listItem = win.presets.ddList.selection;
		if( !listItem )
			return; // выходим
		
		//сохранение текущего набора
		if( listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
			var res = confirmWithCancel( getLocale('savePreset') + " '" + listItem.text + "'?" ); // defaultButton = ok|no|cancel, return true|false|null
			if( res === null )
				return null; //прервать выход 
			else if( res )
				write_xml_file( listItem.presetFile, win.findChange.XML );
			}
		}
		
	}

//=====================================================================
// ============ OPTS DIALOG ================================================
function getOptionsDialog(){
	SHOW_DIALOG = true;
	
	try{
	var win = new Window( "dialog", getLocale('options'), undefined );
	win.alignChildren = ['left', 'top'];
	win.margins = 5;
	win.spacing = 5;

	win.fields = win.add( "panel", undefined, getLocale('columns') );
	win.fields.alignment = ['fill', 'top'];
	win.fields.alignChildren = ['left', 'top'];
	
	addField( 'active', 'Active', true, getLocale('activeHelpTip') );
	addField( 'method', 'Method', true, getLocale('methodHelpTip') );
	addField( 'findWhat', 'Find', false );
	addField( 'findCharStyle', 'findCharStyle', true, getLocale('find')+': '+getLocale('charStyle') );
	addField( 'findParStyle', 'findParStyle', true, getLocale('find')+': '+getLocale('parStyle') );
	addField( 'changeTo', 'Change', false );
	addField( 'changeCharStyle', 'changeCharStyle', true, getLocale('change')+': '+getLocale('charStyle') );
	addField( 'changeParStyle', 'changeParStyle', true, getLocale('change')+': '+getLocale('parStyle') );
	
	win.showReport = win.add( "checkbox", undefined, getLocale('showReport') );
	
	function addField( name, title, checkAccess, helpTip ){
		var group = win.fields.add( "group", undefined, undefined );
		group.alignment = ['fill', 'top'];
		var check = group.add( "checkbox", undefined, '' );
		var statictext = group.add( "statictext", undefined, title + (helpTip?'*':'') );
		if( helpTip )
			statictext.helpTip = helpTip;
		var numberField = group.add( "group", undefined, undefined );
		numberField.alignment = ['right', 'top'];
		var width = name+'Width';
		getUINumberField({
			currentValue: OPTS[width], // Number. Default: 0
			//maxValue: 100, // Number. Default: Number.POSITIVE_INFINITY
			minValue: 10, // Number. Default: Number.NEGATIVE_INFINITY
			//emptyValue: false, // Bool. Default: false. Может ли поле принимать пустое значение
			callback: function( oldNum, newNum ){ OPTS[width] = newNum; return newNum }, // Function. Default: function( oldNum, newNum ){ return newNum }
			
			//uiField: undefined, // EditText object. Если указан этот параметр - нижеследующие параметры не учитываются
			
			uiContainer: numberField, // UI-object: Window, Panel, Group or Tab
			buttons: true, // Bool. Default: false
			step: 10, // Number. Default: 1
			//secondButtons: false, // Bool. Default: false
			//secondStep: 0.1, // Number. Default: 0.1
			//prefix:  getLocale('Width'), // String
			//postfix: '', // String
			//readOnly: false, // Bool. Default: false
			});
		
		if( !checkAccess ){
			check.visible = false;
			}
		else{
			check.value = /*statictext.enabled =*/ numberField.visible = OPTS[name];
			check.onClick = function(){
				OPTS[name] = /*statictext.enabled =*/ numberField.visible = this.value;
				}
			}
		}
	
	// showReport
	win.showReport.onClick = function(){
		OPTS.showReport = this.value;
		}
	win.showReport.value = OPTS.showReport;
	
	win.add('statictext'); // отступ
	win.autor = win.add('statictext', undefined, 'Script by Alexey Dmitrienko | alexey-dmitrienko@ya.ru');
	win.autor.alignment = 'center';
	addFont( win.autor, {size:8} );
	
	// OK
	/*win.OK = win.add( "button", undefined, 'OK' );
	win.OK.alignment = ['center', 'top'];
	win.OK.onClick = function(){
		this.window.close();
		}
	win.defaultElement = win.OK;*/
	
	win.center();
	win.show();
	
	}catch(err){ alertError (err, 'getOptionsDialog()') }
	}

//=====================================================================
//=====================================================================
function getStylesList( style, separator ){ // style = paragraph | character | object
	// v.1
	separator = separator || ' / ';
	style = style.replace(/^./, style[0].toUpperCase());
	var names = [];
	var ids = [];
	var docStyles;
	docStyles = app.documents[0]['all' + style + 'Styles'];
	var groupType = style + 'StyleGroup';
	var parent;
	for(var i=0; i<docStyles.length; i++){
		names[i] = docStyles[i].name;
		parent = docStyles[i].parent;
		while( parent.constructor.name == groupType ){
			names[i] = parent.name + separator + names[i];
			parent = parent.parent;
			}
		ids[names[i]] = docStyles[i].id;
		}
	return { names: names, ids: ids }
	}
//=====================================================================
function alertError( err, sourceOfError ){
	if( !err )
		return;
	var errMessage = err.constructor == Error ? err + '; line: ' + err.line : err;
	errMessage = (sourceOfError? sourceOfError + ': ' : '') + errMessage;
	alert( errMessage );
	}
//=====================================================================
function getFileNameOnly( file ){ // Внимание: для получения имени папки не использовать
	if( file instanceof Folder )
		return getFileName( file );
	return getFileName( file ).split('.').slice(0,-1).join('.');
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1, file.fsName.lastIndexOf('.') )
	}
function getFileName( file ){
	return file.fsName.split(/[\\\/]/).reverse()[0];
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1 );
	}
function getFileExtention( file ){
	if( file instanceof Folder )
		return '';
	return file.fsName.substring( file.fsName.lastIndexOf('.')+1 );
	}
function writeFile( FILE, string, writeMode ){ // return true || false || Error
	if( !FILE )
		return false;
	writeMode = writeMode ? writeMode : 'w';
	try{
	FILE.open( writeMode );
	FILE.encoding = "UTF-8";
	var strings = string.split( /[\r\n]/ );
	for( var i = 0; i < strings.length; i++ )
		FILE.writeln( strings[i] );
//	FILE.write( string );
	FILE.close();
	if( !FILE.exists )
		return false;
	return true;
	}catch(err){
		alertError( err );
		return false;
		}
	}
function write_xml_file( toFile, xml, header ){
	var str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r" + (header ? header+"\r" : "") + xml.toXMLString();
	return writeFile( toFile, str );
	}
function read_xml_file( XMLFile, returnError ){ // return XML or false or Error (if returnError = true)
	try{
	if( !XMLFile.exists )
		throw new Error( 'XML file not found: ' + XMLFile.fsName );
	XMLFile.open('r');
	var res = XMLFile.read();
	XMLFile.close();
	if( !res )
		throw new Error( 'Error read XML file: ' + XMLFile.fsName );
	var myXML = new XML( res );
	if( !myXML )
		throw new Error( 'Error load XML from file: ' + XMLFile.fsName );
	return myXML;
	}catch(err){
		if( returnError )
			return err;
		alertError( err );
		return false;
		}
	}

function adaptForFileName( str ){
	return str.toString().replace(/[\r\n\t\\\/:*?"<>|]+/g, '_');
	}
//=====================================================================
function confirmWithCancel( text, defaultButton ){ // defaultButton = ok|no|cancel, return true|false|null
	// v.1
	var res;
	var _win = new Window( 'dialog' );
	_win.add( 'statictext', undefined, text );
	_win.buts = _win.add( 'group' );
	_win.buts.orientation = 'row';
	_win.buts.ok = _win.buts.add( 'button', undefined, 'Ok', {flag: 'ok'} );
	_win.buts.no = _win.buts.add( 'button', undefined, 'No', {flag: 'no'} );
	_win.buts.cancel = _win.buts.add( 'button', undefined, 'Cancel', {flag: 'cancel'} );
	_win.buts.ok.onClick = _win.buts.no.onClick = _win.buts.cancel.onClick = function(){
		switch( this.properties.flag ){
			case 'ok':
				res = true;
				break;
			case 'no':
				res = false;
				break;
			case 'cancel':
				res = null;
				break;
			}
		_win.close();
		}
	switch( defaultButton ){
		case 'ok':
			_win.defaultElement = _win.buts.ok;
			break;
		case 'no':
			_win.defaultElement = _win.buts.no;
			break;
		case 'cancel':
			_win.defaultElement = _win.buts.cancel;
			break;
		default:
			_win.defaultElement = _win.buts.ok;
		}
	
	_win.center();
	_win.show();
	
	return res;
	}

//=====================================================================
function doFindChange( opts ){ // return Array
	// v.1.3
	// Quick code
	// doFindChange( {type: 'Grep', findWhat: 'zzz', changeTo: 'ddd', area: app.selection[0], findPreferences: false, changePreferences: {fontStyle: "Bold"}, topLevelOnly: false, getFirstFindResultOnly: false} );
	try{
	// opts = {
	//	type: 'Text' or 'Grep'
	//	findWhat: String
	//	changeTo: String. Optional. ВНИМАНИЕ: пустая строка означает замену найденных элементов на пустую строку
	//	area: Object, поддерживающий метод findText или findGrep, или Array of Objects (напр., app.selection)
	//	findPreferences: findTextPreferences or findGrepPreferences. Optional
	//	changePreferences: changeTextPreferences or changeGrepPreferences. Optional
	//	
	//	topLevelOnly: Bool. Optional (default: false). Если true - вложеные page items орабатываться не будут 
	//	getFirstFindResultOnly: Bool.Optional (default: false). 
	//	}
	// INI
	if( !opts )
		return [];
	if( !opts.type || !/^(Text|Grep)$/.test(opts.type) )
		throw new Error( "opts.type = " + opts.type );
	var res = [];
	var area = arguments.length > 1 ? arguments[1] : opts.area;
	if( !area )
		throw new Error( "area = " + area );
	
	if( area instanceof Array ){ // array|app.selection|allPageItems
		var this_res;
		for( var i = 0; i < area.length; i++ ){
			this_res = arguments.callee( opts, area[i] );
			if( this_res.length ){
				if( opts.getFirstFindResultOnly ){
					return [this_res[0]];
					}
				res = res.concat( this_res );
				}
			}
		return res;
		}
	
	if( area.hasOwnProperty("find"+opts.type) ){
		//$.writeln ('opts.findPrefsInitialized: ' + opts.findPrefsInitialized)
		// EXE
		if( !opts.findPrefsInitialized ){ // подгружаем настройки find/change один раз
			var findPrefsStr = 'find' + opts.type + 'Preferences';
			var changePrefsStr = 'change' + opts.type + 'Preferences';
			app[findPrefsStr] = app[changePrefsStr] = null;
			
			var appFindPreferences = app[findPrefsStr];
			appFindPreferences.findWhat = ( opts.findWhat && opts.findWhat.constructor == String ) ? opts.findWhat : NothingEnum.NOTHING;
			if( opts.findPreferences )
				for( var i in opts.findPreferences )
					appFindPreferences[i] = opts.findPreferences[i];
			
			opts.findPrefsInitialized = true;
			
			if( opts.changeTo && opts.changeTo.constructor == String || opts.changePreferences ){
				var appChangePreferences  = app[changePrefsStr];
				appChangePreferences.changeTo = ( opts.changeTo && opts.changeTo.constructor == String ) ? opts.changeTo : NothingEnum.NOTHING;
				var flag = false;
				if( opts.changePreferences )
					for( var i in opts.changePreferences ){
						flag = true;
						appChangePreferences[i] = opts.changePreferences[i];
						}
				if( appChangePreferences.changeTo != NothingEnum.NOTHING || flag )
					opts.changePrefsInitialized = true;
				}
			}
		
		res = area["find"+opts.type]();
		if( res == null )
			return [];
		else if( opts.changePrefsInitialized ){
			try{ area["change"+opts.type](); }catch(err){}
			}
		
		if( opts.getFirstFindResultOnly ){
			return res.length ? [res[0]] : res;
			}
		}
	
	//app[findPrefsStr] = app[changePrefsStr] = null;
	
	// обрабатываем все вложеные page items
	if( !opts.topLevelOnly && area.hasOwnProperty("allPageItems") && area.allPageItems.length ){
		res = res.concat( arguments.callee(opts, area.allPageItems) );
		}
	
	}catch(err){
		alertError( err, 'doFindChange('+(opts.type ? 'type='+opts.type : '')+'). area.constructor.name = ' + area.constructor.name );
		 }
	 
	return res;
	}

//=====================================================================
function getUIQueriesList( uiContainer, columns ){
	// v. 1.2
	/*
	columns = [
		{
			key: "",
			title: "",
			width: 100, // number,
			type: "", // edittext | checkbox | radiobutton | dropdownlist
			default_value: "false",
			values: ["","",""], // array of strings // Only for radiobutton | dropdownlist | multi checkbox
			
			missingValuePrefix: '', // Only for radiobutton | dropdownlist
			missingValuePostfix: '',  // Only for radiobutton | dropdownlist
			checkboxValuesDelimiter: ', ',
			dropdownlistEmptyValue: false, 
			edittextMultiline: false,
			edittextScrolling: false, 
			helpTip: "",
		}
	uiContainer.XML - текущий Xml: <queries><query/></queries>
	uiContainer.loadXml( xml ) - функция загрузки нового xml
	
	// общая ширина блока будет равна сумме всех width
	*/
	var lang = ( $.locale == 'ru_RU' ) ? 'ru' : 'en';
	var messages = {
		en: {
			up: 'Move up selected item',
			down: 'Move down selected item',
			deleteRow: 'Delete selected item',
			},
		ru: {
			up: 'Двигать строку верх по списку',
			down: 'Двигать строку вниз по списку',
			deleteRow: 'Удалить строку',
			}
		};
	
	var titles = [];
	var widths = [];
	var default_xml_node = <query/>;
	for( var i = 0; i < columns.length; i++ ){
		titles.push( columns[i].title || columns[i].key );
		widths.push( columns[i].width );
		default_xml_node.@[columns[i].key] = columns[i].default_value;
		}
	var listColumnsSource = {
		numberOfColumns: columns.length, 
		showHeaders: true, 
		columnTitles: titles,
		columnWidths: widths
		};
	// ширину будет задавать группа listFields, а listButs и listBox просто растягиваются по ширине
	uiContainer.orientation = 'column';
	uiContainer.alignChildren = ['left', 'top'];
	uiContainer.spacing = 5;
	uiContainer.XML = <queries/>; // объект настроек по умолчанию
	with(uiContainer){
		uiContainer.listButs = add( "group", undefined, undefined );
		uiContainer.listButs.alignment = ['fill', 'top'];
		uiContainer.listButs.alignChildren = ['right', 'center'];
		uiContainer.listButs.spacing = 5;
		with(uiContainer.listButs){
			uiContainer.listButs.up = add( "button", undefined, '▲', {name: -1, } );
			uiContainer.listButs.up.helpTip = messages[lang].up;
			uiContainer.listButs.down = add( "button", undefined, '▼', {name: 1, } );
			uiContainer.listButs.down.helpTip = messages[lang].down;
			uiContainer.listButs.deleteRow = add( "button", undefined, '✖' );
			uiContainer.listButs.deleteRow.preferredSize.width = 22;
			uiContainer.listButs.deleteRow.helpTip = messages[lang].deleteRow;
			}
		/*
		uiContainer.headers = add( "group", undefined, undefined );
		uiContainer.headers.alignChildren = ['left', 'top'];
		uiContainer.headers.spacing = 5;
		with(uiContainer.headers){
			for( var i = 0; i < columns.length; i++ )
				add( 'statictext', undefined, listColumnsSource.columnTitles[i]).preferredSize.width = columns[i].width - (i == columns.length-1 ? 0 : 5); // уменьшаем на размер отступа, последний не уменьшаем
			}
		*/
		uiContainer.listBox = add( "listbox", undefined, undefined, listColumnsSource );
		uiContainer.listBox.preferredSize.height = 200;
		uiContainer.listBox.alignment = ['fill', 'top'];
		uiContainer.listFields = add( "group", undefined, undefined );
		uiContainer.listFields.alignChildren = ['left', 'top'];
		uiContainer.listFields.spacing = 5;
		with(uiContainer.listFields){
			for( var i = 0; i < columns.length; i++ ){
				switch( columns[i].type ){
					case 'edittext':
						var multiline = columns[i].edittextMultiline ? true : false;
						var scrolling = columns[i].edittextScrolling ? true : false;
						uiContainer.listFields[i] = add( 'edittext', undefined, undefined, {multiline: multiline, scrolling: scrolling} );
						if( multiline )
							uiContainer.listFields[i].alignment = ['fill', 'fill'];
						uiContainer.listFields[i].onChange = editField;
						break;
					case 'checkbox':
						if( columns[i].values ){
							uiContainer.listFields[i] = add( 'group', undefined, undefined );
							uiContainer.listFields[i].delimiter = columns[i].hasOwnProperty('checkboxValuesDelimiter') && columns[i].checkboxValuesDelimiter.constructor == String ? columns[i].checkboxValuesDelimiter : ', ';
							columns[i].valuesBasa = {};
							with( uiContainer.listFields[i] ){
								alignChildren = ['left', 'top'];
								orientation = 'column';
								spacing = 5;
								var checkbox;
								for( var z = 0; z < columns[i].values.length; z++ ){
									checkbox = add( 'checkbox', undefined, columns[i].values[z] );
									checkbox.multi = true;
									checkbox.onClick = editField;
									columns[i].valuesBasa[columns[i].values[z]] = true;
									}
								}
							}
						else{
							uiContainer.listFields[i] = add( 'checkbox', undefined, '' );
							uiContainer.listFields[i].onClick = editField;
							}
						break;
					case 'dropdownlist':
						var list = columns[i].dropdownlistEmptyValue ? ['', '-'].concat(columns[i].values) : columns[i].values;
						uiContainer.listFields[i] = add( 'dropdownlist', undefined, list );
						uiContainer.listFields[i].onChange = editField;
						break;
					case 'radiobutton':
						uiContainer.listFields[i] = add( 'group', undefined, undefined );
						columns[i].valuesBasa = {};
						with( uiContainer.listFields[i] ){
							alignChildren = ['left', 'top'];
							orientation = 'column';
							spacing = 5;
							for( var z = 0; z < columns[i].values.length; z++ ){
								add( 'radiobutton', undefined, columns[i].values[z] ).onClick = editField;
								columns[i].valuesBasa[columns[i].values[z]] = true;
								}
							}
						break;
					}
				uiContainer.listFields[i].Key = columns[i].key;
				uiContainer.listFields[i].Index = i;
				uiContainer.listFields[i].preferredSize.width = columns[i].width - (i == columns.length-1 ? 0 : 5); // уменьшаем на размер отступа, последний не уменьшаем
				if( columns[i].helpTip )
					uiContainer.listFields[i].helpTip = columns[i].helpTip;
				}
			}
		}
	
	// initialize - инициируем список для расстановки ширины столбцов
	uiContainer.listBox.removeAll();
	uiContainer.listBox.add( 'item', '...' ).addListRow = true;
	
	function getTextForCell( text, uiType ){
		if( uiType == 'checkbox' ){
			text = text.toString();
			if( text == 'false' )
				return '';
			if( text == 'true' )
				return '+';
			}
		return text;
		}
	// Работа с данными поля
	function editField( e ){
		try{
			
		if( !uiContainer.listBox.selection )
			return;
		
		var uiObject = e ? e.target : this;
		
		if( uiObject.SLEEP )
			return;
		
		//var currentUIObject = e ? e.currentTarget : this;
		var row = uiContainer.listBox.selection;

		var uiField = uiObject;
		
		var value = '';
		var xmlValue;
		if( uiObject.type == 'edittext' )
			value = xmlValue = uiObject.text;
		else if( uiObject.type == 'checkbox' ){
			if( uiObject.multi ){
				uiField = uiObject.parent;
				value = [];
				for( var i = 0; i < uiObject.parent.children.length; i++ ){
					if( uiObject.parent.children[i].value )
						value.push( uiObject.parent.children[i].text );
					}
				xmlValue = value.join( '__DELIMITER__' );
				value = value.join( uiField.delimiter );
				}
			else
				value = xmlValue = uiObject.value.toString();
			}
		else if( uiObject.type == 'radiobutton' ){
			uiField = uiObject.parent;
			value = xmlValue = uiObject.text;
			}
		else if( uiObject.type == 'dropdownlist' )
			value = xmlValue = uiObject.selection ? uiObject.selection.text : '';
		
		if( !uiField.Index )
			row.text = getTextForCell( value, uiObject.type );
		else
			row.subItems[uiField.Index-1].text = getTextForCell( value, uiObject.type );
		row.xmlNode.@[uiField.Key] = xmlValue;
		
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Перемещение
	uiContainer.listButs.up.onClick = uiContainer.listButs.down.onClick = function(){
		try{
		var listBox = uiContainer.listBox;
		if(listBox.selection == null || listBox.items.length < 2 )
			return;
		if(this.properties.name == -1 && listBox.selection.index == 0)
			return;
		if(this.properties.name == 1 && listBox.selection.index == listBox.items.length-2)
			return;
		var item = listBox.selection;
		var nextItem = listBox.items[listBox.selection.index + this.properties.name];
		
		var fields = uiContainer.listFields.children;
		var this_list_item, next_list_item, listValue, xmlValue;
		for( var i = 0; i < fields.length; i++ ){
			this_list_item = i == 0 ? item : item.subItems[i-1];
			next_list_item = i == 0 ? nextItem : nextItem.subItems[i-1];
			
			// запоминаем
			xmlValue = item.xmlNode.@[fields[i].Key].toString();
			listValue = this_list_item.text;
			
			// перебрасываем
			item.xmlNode.@[fields[i].Key] = nextItem.xmlNode.@[fields[i].Key].toString();
			this_list_item.text = next_list_item.text;
			
			nextItem.xmlNode.@[fields[i].Key] = xmlValue;
			next_list_item.text = listValue;
			}
		
		listBox.selection = nextItem;
		}catch(err){ alert( err + ', line ' + err.line, 'up/down' ) }
		}
	// Удаление
	uiContainer.listButs.deleteRow.onClick = function(){
		try{
		if( !uiContainer.listBox.selection )
			return;
		if( !confirm('Delete row?') )
			return;
		var item = uiContainer.listBox.selection;
		// удаляем узел. По ссылке item.xmlNode удалить не получится, поэтому идем окольным путем
		delete item.xmlNode.parent().children()[item.xmlNode.childIndex()];
		var next_item_index = item.index ? item.index-1 : (uiContainer.listBox.items.length > 2 ? item.index : null );
		uiContainer.listBox.remove( item );
		if( next_item_index !== null )
			uiContainer.listBox.selection = next_item_index;
		}catch(err){ alert( err + ', line ' + err.line, 'deleteRow()' ) }
		}
	// Выбор
	uiContainer.listBox.onChange = function(){
		try{
		if( !this.selection )
			return;
		if( this.selection.addListRow ){
			uiContainer.addListRow();
			return;
			}
		fillFields( this.selection.xmlNode );
		}catch(err){ alert( err + ', line ' + err.line, 'onChange()' ) }
		}
	// Добавление
	uiContainer.addListRow = function( xmlNode, notFillFields ){
		try{
		if( this.SLEEP )
			return;
		
		if( !xmlNode ){
			xmlNode = default_xml_node.copy();
			this.XML.appendChild( xmlNode );
			}
		var item = this.listBox.items[this.listBox.items.length-1];
		item.text = ''; // убираем многоточие
		item.xmlNode = xmlNode;
		
		item.addListRow = false;
		var addListRow = this.listBox.add( 'item', '...' );
		addListRow.addListRow = true;
		
		// Заполняем значения строки
		var fields = uiContainer.listFields.children;
		var this_list_item, text;
		for( var i = 0; i < fields.length; i++ ){
			this_list_item = i == 0 ? item : item.subItems[i-1];
			
			// multi checkbox
			if( fields[i].type == 'group' && fields[i].children[0].type == 'checkbox' ){
				
				var values = item.xmlNode.@[fields[i].Key].toString().split( '__DELIMITER__' );
				
				for( var z = 0; z < values.length; z++ ){
					if( values[z] && !columns[i].valuesBasa[values[z]] ){
						if( columns[i].missingValuePrefix )
							values[z] = columns[i].missingValuePrefix + values[z];
						if( columns[i].missingValuePostfix )
							values[z] = values[z] + columns[i].missingValuePostfix;
						}
					}
				
				text = values.join( fields[i].delimiter );
				
				}
			else{
				
				text = getTextForCell( item.xmlNode.@[fields[i].Key].toString(), fields[i].type );
				
				if( text ){
					if( (fields[i].type == 'dropdownlist' && !fields[i].find(text)) || (fields[i].type == 'group' && !columns[i].valuesBasa[text]) ){ 
						if( columns[i].missingValuePrefix )
							text = columns[i].missingValuePrefix + text;
						if( columns[i].missingValuePostfix )
							text = text + columns[i].missingValuePostfix;
						}
					}
				}
			
			this_list_item.text = text;
			}
		
		// Выделяем
		this.SLEEP = true;
		this.listBox.selection = item;
		this.SLEEP = false;
		
		// Заполняем поля
		if( !notFillFields )
			fillFields( item.xmlNode );
		
		}catch(err){ alert( err + ', line ' + err.line, 'addListRow()' ) }
		}
	// Заполнение полей
	function fillFields( xmlNode ){ // Если xmlNode не указан - поля просто очищаются
		var fields = uiContainer.listFields.children;
		for( var i = 0; i < fields.length; i++ ){
			var value = xmlNode ? xmlNode.@[fields[i].Key].toString() : '';
			switch( fields[i].type ){
				case 'edittext':
					fields[i].text = value;
					break;
				case 'checkbox':
					fields[i].value = value == 'true';
					break;
				case 'dropdownlist':
					fields[i].SLEEP = true;
					fields[i].selection = fields[i].find( value );
					fields[i].SLEEP = false;
					break;
				case 'group':
					if( fields[i].children[0].type == 'radiobutton' ){
						for( var z = 0; z < fields[i].children.length; z++ ){
							if( fields[i].children[z].text == value ){
								fields[i].children[z].value = true;
								break;
								}
							fields[i].children[z].value = false;
							}
						}
					else if( fields[i].children[0].type == 'checkbox' ){
							var values = value.split( '__DELIMITER__' );
							var basa = {};
							for( var z = 0; z < values.length; z++ )
								basa[values[z]] = true;
							for( var z = 0; z < fields[i].children.length; z++ )
								fields[i].children[z].value = basa[fields[i].children[z].text];
						}
					break;
				}
			}
		}
	// Загрузка набора
	uiContainer.loadXml = function( xml ){
		// Очищаем
		while( uiContainer.listBox.items.length > 1 )
			uiContainer.listBox.remove( uiContainer.listBox.items[0] );
		// Очищаем поля
		fillFields();
		
		uiContainer.XML = xml;
		var rows = xml.elements();
		var last_index = rows.length() - 1;
		for( var i = 0; i <= last_index; i++ )
			uiContainer.addListRow( rows[i], (i != last_index) ); // показываем только последний
		}
	}
//=====================================================================
function getUINumberField( properties ){
	// v.3.3
	/*
	properties = {
		currentValue: 0, // Number. Default: 0
		maxValue: 100, // Number. Default: Number.POSITIVE_INFINITY
		minValue: 1, // Number. Default: Number.NEGATIVE_INFINITY
		emptyValue: false, // Bool. Default: false. Может ли поле принимать пустое значение
		callback: function( oldNum, newNum ){ return newNum }, // Function. Default: function( oldNum, newNum ){ return newNum }
		
		uiField: undefined, // EditText object. Если указан этот параметр - нижеследующие параметры не учитываются
		
		uiContainer: undefined, // UI-object: Window, Panel, Group or Tab
		buttons: false, // Bool. Default: false
		step: 1, // Number. Default: 1
		secondButtons: false, // Bool. Default: false
		secondStep: 0.1, // Number. Default: 0.1
		prefix: '', // String
		postfix: '', // String
		readOnly: false, // Bool. Default: false
		}
	return object {
		currentValue: num или '' (пустая строка при пустом значении поля),
		minValue: num,
		maxValue: num,
		step: num,
		secondStep: num,
		enabled: bool,
		readOnly: bool,
		}
	При изменении значений minValue и maxValue после создания объекта следует обновлять значение currentValue: numberField.currentValue = numberField.currentValue
	*/
	properties = properties ? properties : {};
	// вычисляем начальное значение
	var numberField = {
		// edited values
		currentValue: properties.emptyValue ? getNumber( properties.currentValue, '' ) : getNumber( properties.currentValue, 0 ), // default: '' или 0
		minValue: getNumber( properties.minValue, Number.NEGATIVE_INFINITY ), // default: Number.NEGATIVE_INFINITY
		maxValue: getNumber( properties.maxValue, Number.POSITIVE_INFINITY ), // default: Number.POSITIVE_INFINITY
		step: getNumber( properties.step, 1 ), // default: 1
		secondStep: getNumber( properties.secondStep, 0.1 ), // default: 0.1
		enabled: true,
		readOnly: ( properties.readOnly ? true : false ),
		}
	// static values
	var callback = ( properties.callback && properties.callback.constructor == Function ? properties.callback : function( oldNum, newNum ){ return newNum } );
	var buttons = properties.buttons || false; // default: false
	var secondButtons = properties.secondButtons || false; // default: false
	var prefix = properties.prefix || '';
	var postfix = properties.postfix || '';
//			var readOnly = ( properties.readOnly ? true : false ); // default: false
	
	var textField;
	var parentGroup;
	if( properties.uiField && properties.uiField.constructor == EditText ){ // используем переданный 
		textField = properties.uiField;
		textField.text = numberField.currentValue;
		}
	else{
		var buttons, secondButtons;
		parentGroup = properties.uiContainer.add( 'group' );
		parentGroup.orientation = 'row';
		parentGroup.spacing = 0;
		with( parentGroup ){
			if( prefix )
				parentGroup.add( 'statictext', undefined, prefix.toString() );
			parentGroup.box = add( 'group' );
			parentGroup.box.orientation = 'row';
			parentGroup.box.margins = [5,0,5,0];
			parentGroup.box.spacing = 0;
			with( parentGroup.box ){
				textField = add( 'edittext', undefined, numberField.currentValue ); //, {readonly: readOnly} );
				textField.preferredSize = [70,22];
				}
			if( buttons ){
				buttons = getButtons( parentGroup.box, 'step' );
				if( secondButtons )
					secondButtons = getButtons( parentGroup.box, 'secondStep' );
				}
			if( postfix )
				parentGroup.add( 'statictext', undefined, postfix.toString() );
			}
		}
	textField.enabled = numberField.readOnly ? false : true;
	var regExps = [/,/g, /[^\.\d]/g, /(\..*?)\./];
	textField.onDeactivate = updateTextField;
	textField.onEnterKey = updateTextField;
	function updateTextField(){
		var value = textField.text.replace(regExps[0],'.').replace(regExps[1],'');
		while( value.search(regExps[2]) > -1 )
			value = value.replace(regExps[2], '$1');
		numberField.currentValue = value;
		textField.text = numberField.currentValue;
		textField.textselection = "";
		}
	
	numberField.watch( 'currentValue', numWatcher );
	numberField.watch( 'minValue', numWatcher );
	numberField.watch( 'maxValue', numWatcher );
	numberField.watch( 'readOnly', enabled_readOnly_watcher );
	numberField.watch( 'enabled', enabled_readOnly_watcher );
	// return
	return numberField;
	// =========================================
	// functs
	function getButtons( container , stepKey ){
		var buttons;
		if( File.fs == 'Macintosh' || /photoshop/i.test(app.name) ){
			buttons = container.add( "group", undefined, undefined );
			buttons.orientation = 'column';
			buttons.margins = [0,0,3,0];
			buttons.spacing = 0;
			buttons.preferredSize = [15,22];
			buttons.plus = buttons.add( 'iconbutton' );
			buttons.minus = buttons.add( 'iconbutton' );
			buttons.plus.preferredSize = buttons.minus.preferredSize = [15,11];
			buttons.plus.onClick = function(){
				numberField.currentValue = Number( numberField.currentValue.toString() ) + numberField[stepKey];
				}
			buttons.minus.onClick = function(){
				numberField.currentValue = Number( numberField.currentValue.toString() ) - numberField[stepKey];
				}
			}
		else{
			buttons = container.add( "scrollbar", undefined, undefined );
			buttons.preferredSize = [20,22];
			buttons.onChanging = function(){
				if( this.value )
					numberField.currentValue = Number( numberField.currentValue.toString() ) - numberField[stepKey];
				else
					numberField.currentValue = Number( numberField.currentValue.toString() ) + numberField[stepKey];
				this.value = 0;
				}
			}
		numberField.watch( stepKey, numWatcher );
		return buttons;
		}
	function enabled_readOnly_watcher(){ // arguments = [имя свойства, старое значение, новое значение]
		// INI
		if(arguments[1] === arguments[2])
			return arguments[1];
		var newValue;
		if(arguments[2] === true)
			newValue = true;
		else if(arguments[2] === false)
			newValue = false;
		else // incorrect type
			return arguments[1];
		// EXE
		if( arguments[0] == 'enabled' ){
			if( parentGroup )
				parentGroup.enabled = newValue;
			else if( numberField.readOnly != !newValue )
				numberField.readOnly = !newValue;
			return newValue;
			}
		else if( arguments[0] == 'readOnly' ){
			textField.enabled = !newValue;
			if( !parentGroup && numberField.enabled != !newValue )
				numberField.enabled = !newValue;
			return newValue;
			}
		else return arguments[1];
		};
	function numWatcher(){ // arguments = [имя свойства, старое значение, новое значение]
		var num = null;
		// пустое значение
		if( arguments[2] === '' && arguments[0] == 'currentValue' ){
			if( properties.emptyValue ){ // если допускается пустое значение
				num = '';
				if( num !== arguments[1] ){
					var callback_num = callback( arguments[1], num );
					if( num !== callback_num && !isNaN(getNumber(callback_num, NaN)) )
						num = callback_num;
					}
				textField.text = num;
				return num;
				}
			else // если не допускается - начначаем ноль
				num = 0;
			}
		
		if( num === null ){
			num = getNumber( arguments[2], NaN );
			if( isNaN(num) )
				num = arguments[1];
		}
		if( arguments[0] == 'currentValue' ){
			if( num > numberField.maxValue )
				num = numberField.maxValue;
			else if( num < numberField.minValue )
				num = numberField.minValue;
			if( num != arguments[1] ){
				var callback_num = callback( arguments[1], num );
				if( num !== callback_num && !isNaN(getNumber(callback_num, NaN)) ){
					if( numberField.minValue > callback_num )
						num = numberField.minValue;
					else if( numberField.maxValue < callback_num )
						num = numberField.maxValue;
					else
						num = callback_num;
					}
				}
			textField.text = num;
			}
		return num;
		}
	function getNumber( value, defaultValue ){
		return value === 0 || ( value && isFinite(value) ) ? +value : defaultValue;
		}
	}


//=====================================================================
// взято из quickRangePrint 5.0
function addIcon( opts ){ // opts = { iconButton, iconPath, text, helpTip }
	try{
	var icon;
	if( opts.iconPath.split('.').reverse()[0].toLowerCase() == 'idrc' ){
		icon = getInDesignIcon( opts.iconPath ); // example: script.getInDesignIcon( '/Text/(Find and Change Panel Resources)/idrc_PNGA/113.idrc' );
		if( !icon ){
	//		alert( 'Incorrect path: ' + opts.iconPath );
			}
		}
	else{
		var file = new File(opts.iconPath);
		if( !file.exists ){
	//		alert 'File not found: ' + file.fsName );
			}
		else
			icon = ScriptUI.newImage( file.fsName );
		}
	
	if( icon ){
//		var uiObject_size = opts.iconButton.size ? opts.iconButton.size : opts.iconButton.preferredSize;
//		if( icon.size[0] <= uiObject_size[0] && icon.size[1] <= uiObject_size[1] )
			opts.iconButton.image = icon;
//		else{  // если иконка  не вписывается в габариты
//			getCustomDraw(opts.iconButton, {uiImage: icon});
//			}
		opts.iconButton.active = false;
		}
	else if( opts.text )
		getCustomDraw(opts.iconButton, {text:opts.text});
	
	if( opts.helpTip )
		opts.iconButton.helpTip = opts.helpTip;
	
	return true;
	}catch( err ){
		alert (err  + ', line ' + err.line );
		return err;
		}
	}
function getInDesignIcon( iconCataloquePath ){
//	if( iconCataloquePath && (parseFloat(app.version)-2) >= 5 ){
		if( File.fs == 'Macintosh' )
			iconCataloquePath = iconCataloquePath.replace( /\(([^()]+) Resources\)/, '$1.InDesignPlugin/Versions/A/Resources' );
		if( new File(iconCataloquePath).exists )
			return ScriptUI.newImage( iconCataloquePath );
		// если это неполный путь из каталога - наращиваем
		iconCataloquePath = new File( app.filePath ).fsName + '/Plug-Ins/' + iconCataloquePath;
	//	$.writeln( iconCataloquePath );
		if( new File(iconCataloquePath).exists )
			return ScriptUI.newImage( iconCataloquePath );
//		}
	return false;
	}

function addFont( uiObject, args ){// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Normal, Bold, Italic, Bolditalic)
	if( args ){
		try{
		if( args.font || args.style || args.size ){
			args.font = args.font || uiObject.graphics.font.name;
			args.style = args.style || uiObject.graphics.font.style;
			args.size = args.size || uiObject.graphics.font.size;
			return uiObject.graphics.font = ScriptUI.newFont(args.font, args.style, args.size);
			}
		else if( args.graphics && args.graphics.font ) //если через args передан uiobject
			return uiObject.graphics.font = args.graphics.font;
		}catch(err){}
		}
	try{ return uiObject.graphics.font }catch(err){ return false }
	}